<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'area';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 实例化
include_once (ROOT_PATH . 'include/area.class.php');
$dou_area = new Area();

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 单页面列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['area_list']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['area_add'],
            'href' => 'area.php?rec=add' 
    ));
    
    // 赋值给模板
    $smarty->assign('area_list', $area_list = $dou_area->get_area_all());
    
    $smarty->display('area.htm');
} 

/**
 * +----------------------------------------------------------
 * 单页面添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['area_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['area_list'],
            'href' => 'area.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('area_list', $dou_area->get_area_nolevel());
    
    $smarty->display('area.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['name'] . $_LANG['is_empty']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('area') . " (id, parent_id, name, sort)" . " VALUES (NULL, '$_POST[parent_id]', '$_POST[name]', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['area_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['area_add_succes'], 'area.php');
} 

/**
 * +----------------------------------------------------------
 * 单页面编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['area_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['area_list'],
            'href' => 'area.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $area = $dou->get_row('area', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('area_list', $dou_area->get_area_nolevel(0, 0, $id));
    $smarty->assign('area', $area);
    
    $smarty->display('area.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['name'] . $_LANG['is_empty']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('area') . " SET parent_id = '$_POST[parent_id]', name = '$_POST[name]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['area_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['area_edit_succes'], 'area.php', '', '3');
}

/**
 * +----------------------------------------------------------
 * 单页面删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'area.php');
    
    $name = $dou->get_one("SELECT name FROM " . $dou->table('area') . " WHERE id = '$id'");
    $is_parent = $dou->get_one("SELECT id FROM " . $dou->table('area') . " WHERE parent_id = '$id'");
    
    if ($id == '1') {
        $dou->dou_msg($_LANG['area_del_wrong'], 'area.php', '', '3');
    } elseif ($is_parent) {
        $_LANG['area_del_is_parent'] = preg_replace('/d%/Ums', $name, $_LANG['area_del_is_parent']);
        $dou->dou_msg($_LANG['area_del_is_parent'], 'area.php', '', '3');
    } else {
        if (isset($_POST['confirm'])) {
            $dou->create_admin_log($_LANG['area_del'] . ': ' . $name);
            $dou->delete('area', "id = '$id'", 'area.php');
        } else {
            $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
            $dou->dou_msg($_LANG['del_check'], 'area.php', '', '30', "area.php?rec=del&id=$id");
        }
    }
}

?>