<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Area {
    /**
     * +----------------------------------------------------------
     * 获取有层次的栏目分类，有几层分类就创建几维数组
     * +----------------------------------------------------------
     * $parent_id 默认获取一级导航
     * $current_id 当前页面栏目ID
     * +----------------------------------------------------------
     */
    function get_area_all($parent_id = 0, $current_id = '') {
        $area_list = array ();
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('area') . " ORDER BY sort ASC, id ASC");
        foreach ((array) $data as $value) {
            // $parent_id将在嵌套函数中随之变化
            if ($value['parent_id'] == $parent_id) {
                foreach ($data as $child) {
                    // 筛选下级导航
                    if ($child['parent_id'] == $value['id']) {
                        // 嵌套函数获取子分类
                        $value['child'] = $this->get_area_all($value['id'], $current_id);
                        break;
                    }
                }
                $area_list[] = $value;
            }
        }
        
        return $area_list;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取无层次单页面列表
     * +----------------------------------------------------------
     * $parent_id 调用该ID下的所有单页面，为空时则调用所有
     * $level 无限极分类层次
     * $current_id 当前页面栏目ID
     * $mark 无限极分类标记
     * +----------------------------------------------------------
     */
    function get_area_nolevel($parent_id = 0, $level = 0, $current_id = '', &$area_nolevel = array(), $mark = '-') {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('area') . " ORDER BY id ASC");
        foreach ((array) $data as $value) {
            if ($value['parent_id'] == $parent_id && $value['id'] != $current_id) {
                $value['mark'] = str_repeat($mark, $level);
                $value['level'] = $level;
                $area_nolevel[] = $value;
                $this->get_area_nolevel($value['id'], $level + 1, $current_id, $area_nolevel);
            }
        }
        return $area_nolevel;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取地区列表
     * +----------------------------------------------------------
     * $parent_id
     * $current 选中的地区
     * +----------------------------------------------------------
     */
    function get_area_list($parent_id = 0, $current = '') {
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('area') . " WHERE parent_id = '$parent_id' ORDER BY sort ASC, id ASC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $area_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "cur" => $row['name'] == $current ? true : false
            );
        }
        
        return $area_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取地区列表
     * +----------------------------------------------------------
     */
    function get_contact($id) {
        $contact = $GLOBALS['dou']->get_row('user_contact', '*', "id = '$id'");
        
        $contact['selectedProvince'] = $contact['province'];
        $contact['selectedCity'] = $contact['city'];
        $contact['selectedDistrict'] = $contact['district'];
        
        return $contact;
    }

}
?>