/**
 +----------------------------------------------------------
 */
var vm = new Vue({
    el:'#area',
    data:{
        province_list: [],        // 省数据
        city_list: [],          // 市数据
        district_list: [],       // 区数据
        selectedProvince: null,
        selectedCity: null,
        selectedDistrict: null,
        wrong:''
    },
    
    computed: {
        // 控制区下拉框显示条件
        showDistrictSelect() {
          return this.selectedCity && this.district_list.length > 0;
        }
    },

    created() {
        if (id) {
            this.init();
        } else {
            this.provinceList();
        }
    },
    
    methods:{
        // 初始化
        init:function() {
            this.$http.post(root_url + 'user.php?rec=area',{type:'init', id:id},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.contact) {
                    this.selectedProvince = res.data.contact.selectedProvince;
                    this.provinceList();
                 
                    if (res.data.contact.selectedCity) {
                        this.selectedCity = res.data.contact.selectedCity;
                        this.cityList();
                    }
                    
                    if (res.data.contact.selectedDistrict) {
                        this.selectedDistrict = res.data.contact.selectedDistrict;
                        this.districtList();
                    }
                }
            },function(res){
                console.log(res.data)
            })
        },
        
        // 省份列表
        provinceList:function() {
            this.$http.post(root_url + 'user.php?rec=area',{type:'province', current:this.selectedProvince},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                if (res.data.area_list) {
                    this.province_list = res.data.area_list;
                }
            },function(res){
                console.log(res.data)
            })
        },
     
        // 城市列表
        cityList:function() {
            this.$http.post(root_url + 'user.php?rec=area',{type:'city', parent:this.selectedProvince, current:this.selectedCity},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                if (res.data.area_list) {
                    this.city_list = res.data.area_list;
                }
            },function(res){
                console.log(res.data)
            })
        },

        // 获取区县数据
        districtList() {
            this.$http.post(root_url + 'user.php?rec=area',{type:'district', parent:this.selectedCity, current:this.selectedDistrict},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                if (res.data.area_list) {
                    this.district_list = res.data.area_list;
                }
            },function(res){
                console.log(res.data)
            })
        },

        // 省份选择变化处理
        handleProvinceChange() {
            this.selectedCity = null;
            this.selectedDistrict = null;
            this.district_list = [];

            if (this.selectedProvince) {
                this.cityList();
            } else {
                this.city_list = [];
            }
        },

        // 城市选择变化处理
        handleCityChange() {
            this.selectedDistrict = null;
            if (this.selectedCity) {
                this.districtList();
            } else {
                this.district_list = [];
            }
        }
    },
})